Subject: Re: [lojban] Chomskyan universals and Lojban

From: John Cowan <[email-masked]>
Date: Fri, 17 Aug 2001 12:41:13 -0400

And Rosta wrote:

> Natlang syntax conforms to the principle that every phrase is a
> projection of a word it dominates (= contains) -- this word is the
> head. (= 'Endocentricity'.) A phrase that is a projection of a
> noun -- i.e. a phrase headed by a noun -- is a Noun Phrase.
>
> There is no such requirement in the formalism used for the formal
> Lojban grammar, which is formally much less restrictive than
> endocentric grammars.

I don't see how. There can only be one non-terminal on the left
side of a yacc/BNF rewrite rule (Chomsky Type 2 grammar), so the head of
a non-terminal, whatever it may be, must necessarily be physically
within the non-terminal.

> If you tell me the meaning of _florgendorf_ and its valency (i.e. its
> transitivity type) then I can predict with an extremely high degree of
> accuracy which semantic argument is expressed by which syntactic
> argument.

If you have to know the meaning, you have scored an own goal:
what is (semantic, urgh) meaning but a generalization of place
structure?

> It may be helpful to know that whereas in programming, 'recursion' and
> 'iteration' are kinds of *procedures*, in linguistics 'recursion' is
> a declarative/representational property whereby the rule defining
> things of type X itself involves things of type X (e.g. X -> X Y).

Mathematicians call this "inductive definition": an inductive
definition can always be implemented by a recursive program.
Note that if X is *solely* defined as X Y, the induction has no
"base" or "ground" case and is useless: it is not enough to
say that something is a natural number if its predecessor is
also; one must also say that zero is a natural number.
This sense of "induction" is quite distinct from the usual sense.

> I can't reconstruct the reasoning, but I have been told, and had it
> demonstrated to me, that representational recursion can always be
> implemented by nonrecursive procedures.

Provided you have a stack to remember the current state on, yes.
In practice people's stacks are not very deep, which is why we don't do
center-embedding well. If the recursive element is at the
end of the rule (Lisp programmers call this "tail recursion",
Prolog programmers say "last call optimization", same thing), then
no stack is required: one can just jump to the beginning of the rule
and start over. From the Jargon File:

Recursion: See recursion. See also tail recursion.

Tail recursion: If you aren't sick of it already, see tail recursion.

-- 
There is / one art || John Cowan <[email-masked]>
no more / no less || http://www.reutershealth.com
to do / all things || http://www.ccil.org/~cowan
with art- / lessness \\ -- Piet Hein